#include <sys/param.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <termios.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

/* get password from user without echo */

static char passwd[10];

char *getpass(const char * prompt)
{
	struct termio	ti;
	char		ch;
	int		cnt = 8;
	char *		buf = passwd;
		
	(void)ioctl(0, TCGETA, &ti);
	ti.c_lflag &= ~ECHO;
	
	printf(prompt); fflush(stdout);

	/* echo off */
	(void)ioctl(0, TCSETA, &ti);

	/* fgets() won't do for variable length passwords, and we
	   can't use gets() of security reasons */
	while(--cnt >= 0 && read(0, &ch, 1) == 1 && ch != '\n')
		*buf++ = ch;

	*buf = '\0';	

	/* suck up extra chars, so they don't go to the shell */
	while(ch != '\n' && read(0, &ch, 1) == 1) /* nothing */;
	
	ti.c_lflag |= ECHO;
	(void)ioctl(0, TCSETA, &ti);

	putchar('\n');

	/* not really needed, but.... */
	(void) ioctl(0, TCFLSH, 2);	/* flush input and output buffers */
	
	return passwd;
}
