#define __LIBRARY__
#define exit	libc_exit
#define uselib	libc_uselib
#define write	libc_write
#include <unistd.h>
#include <errno.h>
#undef exit
#undef uselib
#undef write

#include <stdarg.h>
#include <sharedlib.h>

static inline volatile void
_exit(int exit_code)
{
  register int __fooebx __asm__ ("bx") = exit_code;
  __asm__("int $0x80"::"a" (__NR_exit),"r" (__fooebx));
}

static inline
_SYSCALL1(int,uselib,const char *,filename)

static
_SYSCALL3(int,write,int,fd,const char *,buf,off_t,count)

static inline int
length(const char *str)
{
  const char *p;
  for (p = str; *p; p++);
  return p - str;
}

static void
__lib_print (int fd, ...)
{
  char *cp;
  va_list ap;

  va_start(ap, fd);
  for (cp = va_arg(ap, char *); cp; cp = va_arg(ap, char *))
      write (fd, cp, length(cp));
  va_end(ap);
}

static void inline
__shlib_fatal (const char *argv0, const char *lib, int err)
{
  __lib_print (2, argv0, ": can't load library '", lib, "'\r\n\t",
	NULL);

  switch (err) {
  case EINVAL:
    __lib_print (2, "Invalid argument: Over the limits?\r\n", NULL);
    break;
  case ENOENT:
    __lib_print (2, "No such file or directory.\r\n", NULL);
    break;
  case EACCES:
    __lib_print (2, "Permission denied.\r\n", NULL);
    break;
  case ENOEXEC:
    __lib_print (2, "Exec format error.\r\n", NULL);
    break;
  }

  while (1)
    _exit (128);
}

extern char * __SHARED_LIBRARIES__[];

void
__load_shared_libraries (int argc, char **argv)
{
  int ret;
  char **ptr;

  if (argc > 0) {
    for (ptr = __SHARED_LIBRARIES__+2; *ptr; ptr++)
      if (ret = uselib(*ptr))
	__shlib_fatal (argv [0], *ptr, ret);
  }
  else {
    for (ptr = __SHARED_LIBRARIES__+2; *ptr; ptr++)
      __lib_print (1, "\t", *ptr, "\r\n", NULL);

    while (1) _exit (0);
  }
}
