#define __LIBRARY__
#define waitpid libc_waitpid
#include <unistd.h>
#include <errno.h>
#include <sys/wait.h>
#undef waitpid

static inline
_syscall3(pid_t,waitpid,pid_t,pid,int *,wait_stat,int,options)

pid_t wait(int * wait_stat)
{
	return waitpid(WAIT_ANY,wait_stat,0);
}

pid_t wait3(int *wait_stat, int options, struct rusage *reserved)
{
	if (reserved) {
	  errno = EINVAL;
	  return -1;
	}
	return waitpid(WAIT_ANY, wait_stat, options);
}

pid_t wait4(pid_t pid, int *wait_stat, int options,
	struct rusage *reserved)
{
	if (reserved) {
	  errno = EINVAL;
	  return -1;
	}
	return waitpid(pid, wait_stat, options);
}
